//+------------------------------------------------------------------+
//|                                              earlybird____v1.mq4 |
//|                                  Copyright  2007, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#include <stdlib.mqh>
//#include <Tracert.mqh>

//---- input parameters
extern string     Expert_Name = "---- oilfxpro_early bird----";

extern int        Magic            = 99999;
extern int        Slippage         = 6;

extern string     Main_Parameters = " Trade Volume & Trade Method";

extern string     Data = " Input Data "; 
extern int        StartTime        = 5;
extern int        MinuteforOpen    =  5;
extern int        FridayTrade      =  1;
extern double     InitialStop      = 30;    // Initial Stop in pips 
extern double     TakeProfit       = 70;    // Profit Lock in pips  
extern double     PendOrdGap       = 25;    // Gap for Pending Orders from Open in pips
extern int        DaysBack         =  3;

extern string     MM_Parameters = " MoneyManagement";
extern double Lots = 0.1;
extern bool Auto_Lots = false;
extern int  Risk = 10;
extern double MIN_lots = 0.1;
extern double MAX_lots = 100;

extern string  Trail = "Price Trail";
extern bool    BreakEvenTrail = true;
extern bool    AutoTrail =true;

extern double  BreakEvenLevel = 60;
extern int     LockInPips = 60;   
extern double  AutoTrailStop = 60;



int      i=0, cnt=0, ticket, mode=0, digit=0, numords, PeriodName ;
double   PrevPrice=0, Price=0, SellProfit=0,BuyProfit=0;
double   BuyStop=0, SellStop=0, BuyPrice=0, SellPrice = 0;
bool     BuyInTrade=false, SellInTrade=false, FirstTime;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   bool FirstTime = true;
//----
   return(0);
  }
  
// ---- Money Management
//*****************************************************************************************************************************************************
//***************************************************************************** M-M *******************************************************************
//*****************************************************************************************************************************************************

double AutoLots(){

   int Decimals = 0;
   int AccLeverage = 100;
   double MaxLotPurchase = 0;
   double ModeLotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
   double ModeLotSize = MarketInfo(Symbol(), MODE_LOTSIZE);
   
   
   if(Auto_Lots == false){
      return(Lots);
   }
       
   if(ModeLotStep == 0.01){
      Decimals = 2;
   }
   if(ModeLotStep == 0.1){
      Decimals = 1;
   }
   
   if(ModeLotSize != 0){
      MaxLotPurchase=((AccountEquity()*AccLeverage)/ModeLotSize)*(Risk*0.01);
   }
   else{
      MaxLotPurchase=MIN_lots;
   }
      
   Lots = StrToDouble(DoubleToStr(MaxLotPurchase,Decimals));
  
   if (Lots < MIN_lots){
      Lots = MIN_lots;
   }
   if (Lots > MAX_lots){
      Lots = MAX_lots;
   }

   return(Lots);    
}

//*****************************************************************************************************************************************************
//***************************************************************************** M-M *******************************************************************
//*****************************************************************************************************************************************************
  
  
  
  
  
//*****************************************************************************************************************************************************
//***************************************************************************** Trailing Stop *******************************************************************
//*****************************************************************************************************************************************************

void TrailPrice(int ticket)
{
   int myTicket;
   datetime ctm;
   double OrderLTS, OrderOP;
   double OrderTP, OrderSL; 
   
   myTicket = ticket;
   
   if (OrderSelect(myTicket,SELECT_BY_TICKET) == true){
      if (OrderCloseTime() == 0){ //order not closed 
      
         OrderOP = OrderOpenPrice();
         OrderTP = OrderTakeProfit();
         OrderSL = OrderStopLoss();
      
         if(OrderType()==OP_BUY){
            
            if (BreakEvenTrail == true){
               BreakEven_TrailingStop(OP_BUY, myTicket, OrderOP, OrderSL, OrderTP);
            }
            if (AutoTrail == true){
               Immediate_TrailingStop(OP_BUY, myTicket, OrderOP, OrderSL, OrderTP);
            }
            
         }
         if(OrderType()==OP_SELL){
            if (BreakEvenTrail == true){
               BreakEven_TrailingStop(OP_SELL, myTicket, OrderOP, OrderSL, OrderTP);
            }
            if (AutoTrail == true){
               Immediate_TrailingStop(OP_SELL, myTicket, OrderOP, OrderSL, OrderTP);
            }
            
         }
      }
   }
}
 
void BreakEven_TrailingStop(int cmd, int ticket, double orderOP, double orderSL, double orderTP ){
   double mySL;
   
   if (cmd == OP_BUY){
       if(Bid >= orderOP + BreakEvenLevel * Point){
         // Check move stop loss
       
         if (orderSL < orderOP){
            // Move Stop to Breakeven + BreakEvenLock
         
            mySL = orderOP + LockInPips * Point; 
            mySL = NormalizeDouble( mySL, Digits);
            
            OrderModify(ticket,orderOP,mySL,orderTP,0,LightGreen);
         
         }
       }
   }
     
   if (cmd == OP_SELL){
        if(Ask <= orderOP - BreakEvenLevel * Point){
        // Check move stop loss
        
          if((orderSL > orderOP) || (orderSL < 0.1)){
             // Move Stop to Breakeven + BreakEvenLock
             mySL = orderOP - LockInPips * Point; 
             mySL= NormalizeDouble( mySL, Digits);
             
             OrderModify(ticket,orderOP,mySL,orderTP,0,Orange);
            
          }
        }
   
   }
   
}

void Immediate_TrailingStop(int cmd, int ticket, double orderOP, double orderSL, double orderTP)
{
   double  mySL;
   
   if (cmd==OP_BUY){
   
     mySL = Bid - AutoTrailStop * Point;
     mySL = NormalizeDouble(mySL, Digits);
     if (orderSL < mySL){
	     OrderModify(ticket,orderOP,mySL,orderTP,0,LightGreen);
     }


   }
   if (cmd==OP_SELL){
   
     mySL = Ask + AutoTrailStop * Point;
    
     mySL = NormalizeDouble(mySL, Digits);
     if (orderSL > mySL){
       Alert("Ask ", Ask," AutoTrail ", AutoTrailStop);
       OrderModify(ticket,orderOP,mySL,orderTP,0,Orange);
     }
     

   }   
}

//*****************************************************************************************************************************************************
//***************************************************************************** Trailing Stop *******************************************************************
//*****************************************************************************************************************************************************
 




// ---- Open Sell Orders
void SellOrdOpen(){		     
        datetime expire=TimeCurrent()+24*3600;
		  
		  
		  if (InitialStop   > 0) SellStop=SellPrice + InitialStop*Point; else SellStop=0;
        if (TakeProfit > 0)    SellProfit=SellPrice - TakeProfit*Point; else SellProfit=0;
	      
		  ticket = OrderSend( Symbol(),OP_SELLSTOP,AutoLots(),
		                      NormalizeDouble(SellPrice, digit),
		                      Slippage,
		                      NormalizeDouble(SellStop , digit),
		                      NormalizeDouble(SellProfit   , digit),
		                      "sell",Magic,expire,Red);
            
        SellInTrade=false;        
            
        if(ticket<0) {
           Print("SELLSTOP: OrderSend failed with error #",GetLastError());
        }
}
// ---- Open Buy Orders
void BuyOrdOpen(){		     

		  datetime expire=TimeCurrent()+24*3600;
		  
		  if (InitialStop > 0) BuyStop = BuyPrice - InitialStop*Point; else BuyStop=0;
        if (TakeProfit>0) BuyProfit=BuyPrice + TakeProfit*Point; else BuyProfit=0;  
		 
		  ticket = OrderSend(Symbol(),OP_BUYSTOP, AutoLots(),
		                     NormalizeDouble(BuyPrice, digit),
		                     Slippage,
		                     NormalizeDouble(BuyStop , digit), 
		                     NormalizeDouble(BuyProfit  , digit),
		                     "buy",Magic,expire,Blue);
                
        BuyInTrade=false;             
            
        if(ticket<0){
           Print("BUYSTOP: OrderSend failed with error #",GetLastError());
        }
}      

// ---- Scan Trades
int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()>=OP_BUY && OrderMagicNumber() == Magic) 
   numords++;
   }
   return(numords);
}
                 	                    
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit(){

   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start(){
   
   static datetime dtBarTime = 0;
   
   
   if(Bars < 1){
      Print("Not enough bars"); return(0);
   }
   
      
   digit  = MarketInfo(Symbol(),MODE_DIGITS);
          
   if (Hour()>=StartTime && Hour()< StartTime+1 && Minute()<= MinuteforOpen ) {  
   
      PrevPrice = iClose(NULL,PERIOD_D1,DaysBack);
      BuyPrice = PrevPrice - PendOrdGap*Point;
      SellPrice = PrevPrice + PendOrdGap*Point;

      
      Price = iClose(NULL,PERIOD_H1,1);
      if ( Price < BuyPrice  ) double Delta = ( BuyPrice - Price )/Point;
      if ( Price > SellPrice ) Delta = ( Price - SellPrice )/Point;
      if ( Price > BuyPrice && Price < SellPrice ) Delta = 0;
   
      bool BuyCondition  = ( Delta > 5 && Price < BuyPrice );
      bool SellCondition = ( Delta > 5 && Price > SellPrice );
   
      
      if(ScanTrades() < 1){
         if (FridayTrade == 0){
            if ( SellCondition && DayOfWeek()!=5) SellOrdOpen();
            if ( BuyCondition  && DayOfWeek()!=5) BuyOrdOpen();
         }
         else{
            if (SellCondition) SellOrdOpen();
            if (BuyCondition)  BuyOrdOpen();   
         }
      }
      
   }
   
   if (dtBarTime == Time[0]) return(0);  
   dtBarTime = Time[0];
   
   if ((BreakEvenTrail == true) || (AutoTrail == true)){
      TrailPrice(ticket);
   }
   return(0);
}






